DECLARE SUB Interrupt (IntNumber%, Registers AS ANY)
DECLARE SUB InterruptX (IntNumber%, Registers AS ANY)
DECLARE FUNCTION Monitor% ()
DECLARE FUNCTION MonText$ (MonType%)

' VIDBUF 1.00 by Alex Boge, 11-9-89.

DEFINT A-Z

TYPE RegType
     AX        AS INTEGER
     BX        AS INTEGER
     CX        AS INTEGER
     DX        AS INTEGER
     BP        AS INTEGER
     SI        AS INTEGER
     DI        AS INTEGER
     Flags     AS INTEGER
     DS        AS INTEGER
     ES        AS INTEGER
END TYPE

DIM Registers AS RegType        'RegType is defined in PDQDECL.BAS

MonType = Monitor
PRINT "Monitor type: "; MonText$(MonType)
IF MonType < 3 THEN
   PhysicalBuffer = &HB000 'monochrome
ELSE
   PhysicalBuffer = &HB800 'color
END IF
PRINT "Physical video buffer= "; HEX$(PhysicalBuffer); ":0000"
Registers.ES = PhysicalBuffer

Registers.CX = &H4445 'set to invalid date  CX='DE'
Registers.DX = &H5351 'spells 'Desq' !      DX='SQ'
Registers.AX = &H2B01 'Set System Date +AL=01H (get DV version info in BX)
CALL Interrupt(&H21, Registers)

IF (Registers.AX AND 255) = &HFF THEN 'if it's "bad" then...
   PRINT "Running under DOS only."
   END
ELSE 'get version number from BX
   BH = Registers.BX \ 256: BL = Registers.BX AND 255
   PRINT "Running under Desqview version "; STR$(BH); "."; BL
END IF

Registers.AX = &HFE00
Registers.DI = 0
CALL InterruptX(&H10, Registers)

PRINT " Logical video buffer= "; HEX$(Registers.ES); ":"; HEX$(Registers.DI)

IF Registers.ES = PhysicalBuffer THEN
   PRINT "Desqview 386 may be virtualizing video."
END IF

END

FUNCTION MonText$ (MonType%) STATIC

SELECT CASE MonType
   CASE 1
      MonText$ = "MDA & Monochrome monitor"
   CASE 2
      MonText$ = "HGC & Monochrome monitor"
   CASE 3
      MonText$ = "CGA & Color monitor"
   CASE 4
      MonText$ = "EGA & Monochrome monitor"
   CASE 5
      MonText$ = "EGA & EGA Color monitor"
   CASE 6
      MonText$ = "VGA & Monochrome monitor"
   CASE 7
      MonText$ = "VGA & VGA Color monitor"
   CASE 8
      MonText$ = "MCGA & Monochrome monitor"
   CASE 9
      MonText$ = "MCGA & VGA Color monitor"
   CASE 10
      MonText$ = "EGA & CGA Color monitor"
   CASE 11
      MonText$ = "IBM 8514/A & Color monitor"
   CASE ELSE
      MonText$ = "Unknown display adapter type"
END SELECT

END FUNCTION

